Subject: Re: e1000 driver and samba

From: Bruce Cole <[email-masked]>
Date: Thu, 20 Sep 2007 16:30:48 -0700

>If you look for it on the Realtek cards, there had been sporadic
>Nissues up to late 2005. The solution posted universally was 'change
>card'.

Yes, that *was* the common recommendation.  But recently I narrowed down the
realtek performance problem most commonly seen with samba (but also applicable
to other TCP applications), and I also narrowed down the fix as well.

The current fix involves re-kicking the TX queue after it becomes stuck.
Apparently it becomes stuck due to a contention problem between the driver and
controller.  I suspect the root problem is the driver isn't properly locking
the TX queue.  It might be worth checking if the queue locking problem exists
in other net drivers as well. 

Reference:
http://www.spinics.net/lists/netdev/msg40384.html